Web lists-archives.com

Re: Recommendation for Virtual Machine and Instructions to set it up?




On Thursday, December 06, 2018 12:59:19 PM Roberto C. Sánchez wrote:
> On Thu, Dec 06, 2018 at 11:11:56AM -0500, rhkramer@xxxxxxxxx wrote:
> > Background:
> > 
> > I'm involved with having some software written and then testing it.
> > 
> > The software won't run on either my Wheezy or Jessie systems -- it
> > appears to be an outdated libstdc++ that is the problem.
> 
> That seems to be rather peculiar.  Is the software also built on the
> wheezy or jessie system 

Nope -- the software was compiled (into a binary) on a Ubuntu system which 
apparently can compile C++17

> before attempting to run it, or is it built
> elsewhere?  

Elsewhere

> What is the exact error output that you get? 

On Wheezy:

rhk@s19:/rhk/downloads2/Scintilla_Dusan$ SciTE 
SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version `CXXABI_1.3.8' not 
found (required by SciTE)
SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version `GLIBCXX_3.4.19' not 
found (required by SciTE)
SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version `CXXABI_1.3.9' not 
found (required by SciTE)
SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version `GLIBCXX_3.4.21' not 
found (required by SciTE)
SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version `GLIBCXX_3.4.20' not 
found (required by SciTE)
rhk@s19:/rhk/downloads2/Scintilla_Dusan$ 

On Jessie, very similar but only mentions two versions not found:  
`CXXABI_1.3.9' and `GLIBCXX_3.4.21'

> What is the
> output of 'ldd /path/to/the/program'?  

On Wheezy (Wheezy is easier for me to send emails to / from):

<quote>
rhk@s19:/rhk/downloads2/Scintilla_Dusan$ ldd /usr/local/bin/SciTE
/usr/local/bin/SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 
`CXXABI_1.3.8' not found (required by /usr/local/bin/SciTE)
/usr/local/bin/SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 
`GLIBCXX_3.4.19' not found (required by /usr/local/bin/SciTE)
/usr/local/bin/SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 
`CXXABI_1.3.9' not found (required by /usr/local/bin/SciTE)
/usr/local/bin/SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 
`GLIBCXX_3.4.21' not found (required by /usr/local/bin/SciTE)
/usr/local/bin/SciTE: /usr/lib/x86_64-linux-gnu/libstdc++.so.6: version 
`GLIBCXX_3.4.20' not found (required by /usr/local/bin/SciTE)
        linux-vdso.so.1 =>  (0x00007ffc32575000)
        libgtk-x11-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgtk-x11-2.0.so.0 
(0x00007f155fdde000)
        libgdk-x11-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgdk-x11-2.0.so.0 
(0x00007f155fb2b000)
        libpangocairo-1.0.so.0 => /usr/lib/x86_64-linux-
gnu/libpangocairo-1.0.so.0 (0x00007f155f91e000)
        libatk-1.0.so.0 => /usr/lib/x86_64-linux-gnu/libatk-1.0.so.0 
(0x00007f155f6fb000)
        libcairo.so.2 => /usr/lib/x86_64-linux-gnu/libcairo.so.2 
(0x00007f155f401000)
        libgdk_pixbuf-2.0.so.0 => /usr/lib/x86_64-linux-
gnu/libgdk_pixbuf-2.0.so.0 (0x00007f155f1e1000)
        libpango-1.0.so.0 => /usr/lib/x86_64-linux-gnu/libpango-1.0.so.0 
(0x00007f155ef94000)
        libgobject-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgobject-2.0.so.0 
(0x00007f155ed44000)
        libgmodule-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgmodule-2.0.so.0 
(0x00007f155eb40000)
        libglib-2.0.so.0 => /lib/x86_64-linux-gnu/libglib-2.0.so.0 
(0x00007f155e848000)
        libstdc++.so.6 => /usr/lib/x86_64-linux-gnu/libstdc++.so.6 
(0x00007f155e541000)
        libm.so.6 => /lib/x86_64-linux-gnu/libm.so.6 (0x00007f155e2bf000)
        libgcc_s.so.1 => /lib/x86_64-linux-gnu/libgcc_s.so.1 
(0x00007f155e0a9000)
        libpthread.so.0 => /lib/x86_64-linux-gnu/libpthread.so.0 
(0x00007f155de8d000)
        libc.so.6 => /lib/x86_64-linux-gnu/libc.so.6 (0x00007f155db00000)
        libX11.so.6 => /usr/lib/x86_64-linux-gnu/libX11.so.6 
(0x00007f155d7c5000)
        libXcomposite.so.1 => /usr/lib/x86_64-linux-gnu/libXcomposite.so.1 
(0x00007f155d5c3000)
        libXdamage.so.1 => /usr/lib/x86_64-linux-gnu/libXdamage.so.1 
(0x00007f155d3c1000)
        libXfixes.so.3 => /usr/lib/x86_64-linux-gnu/libXfixes.so.3 
(0x00007f155d1bb000)
        libgio-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0 
(0x00007f155ce68000)
        libpangoft2-1.0.so.0 => /usr/lib/x86_64-linux-gnu/libpangoft2-1.0.so.0 
(0x00007f155cc3d000)
        libfreetype.so.6 => /usr/lib/x86_64-linux-gnu/libfreetype.so.6 
(0x00007f155c99e000)
        libfontconfig.so.1 => /usr/lib/x86_64-linux-gnu/libfontconfig.so.1 
(0x00007f155c767000)
        libXext.so.6 => /usr/lib/x86_64-linux-gnu/libXext.so.6 
(0x00007f155c555000)
        libXrender.so.1 => /usr/lib/x86_64-linux-gnu/libXrender.so.1 
(0x00007f155c34b000)
        libXinerama.so.1 => /usr/lib/x86_64-linux-gnu/libXinerama.so.1 
(0x00007f155c149000)
        libXi.so.6 => /usr/lib/x86_64-linux-gnu/libXi.so.6 
(0x00007f155bf3a000)
        libXrandr.so.2 => /usr/lib/x86_64-linux-gnu/libXrandr.so.2 
(0x00007f155bd32000)
        libXcursor.so.1 => /usr/lib/x86_64-linux-gnu/libXcursor.so.1 
(0x00007f155bb28000)
        librt.so.1 => /lib/x86_64-linux-gnu/librt.so.1 (0x00007f155b920000)
        libpixman-1.so.0 => /usr/lib/x86_64-linux-gnu/libpixman-1.so.0 
(0x00007f155b69a000)
        libpng12.so.0 => /lib/x86_64-linux-gnu/libpng12.so.0 
(0x00007f155b473000)
        libxcb-shm.so.0 => /usr/lib/x86_64-linux-gnu/libxcb-shm.so.0 
(0x00007f155b270000)
        libxcb-render.so.0 => /usr/lib/x86_64-linux-gnu/libxcb-render.so.0 
(0x00007f155b066000)
        libxcb.so.1 => /usr/lib/x86_64-linux-gnu/libxcb.so.1 
(0x00007f155ae46000)
        libz.so.1 => /lib/x86_64-linux-gnu/libz.so.1 (0x00007f155ac2f000)
        libgthread-2.0.so.0 => /usr/lib/x86_64-linux-gnu/libgthread-2.0.so.0 
(0x00007f155aa2d000)
        libffi.so.5 => /usr/lib/x86_64-linux-gnu/libffi.so.5 (0x00007f155a820000)
        libdl.so.2 => /lib/x86_64-linux-gnu/libdl.so.2 (0x00007f155a61c000)
        libpcre.so.3 => /lib/x86_64-linux-gnu/libpcre.so.3 
(0x00007f155a3df000)
        /lib64/ld-linux-x86-64.so.2 (0x00007f15608d1000)
        libselinux.so.1 => /lib/x86_64-linux-gnu/libselinux.so.1 
(0x00007f155a1bf000)
        libresolv.so.2 => /lib/x86_64-linux-gnu/libresolv.so.2 
(0x00007f1559fa9000)
        libexpat.so.1 => /lib/x86_64-linux-gnu/libexpat.so.1 
(0x00007f1559d7f000)
        libXau.so.6 => /usr/lib/x86_64-linux-gnu/libXau.so.6 
(0x00007f1559b7c000)
        libXdmcp.so.6 => /usr/lib/x86_64-linux-gnu/libXdmcp.so.6 
(0x00007f1559977000)

</quote>

> Is it written in C++?

Yes.

> 
> > We've tried a few different solutions, including trying to install
> > updated libstdc++ library using dpkg -i
> 
> Wow.  That is just asking for trouble.  I strongly recommend against
> that.
> 
> > and having the package compiled statically
> > (although, for some reason, the programmer couldn't get it completed
> > static, it apparently still needs some share libraries).
> 
> That is not especially surprising.  I have just today encountered an
> open source project that I need to build from source that fails to build
> if I try to static link it.

Any idea why -- that was very disappointing, in fact, compiling it static 
added only about 450 bytes to the zip file containing the executable (and 
related stuff -- a .pdf and a bunch of property files and such).